type __ = Obj.t

type 'a sig0 = 'a
  (* singleton inductive, whose constructor was exist *)

type 'a sumor =
  | Inleft of 'a
  | Inright

val le_ge_dec : Int64.t -> Int64.t -> bool

type 'a list =
  | Nil
  | Cons of 'a * 'a list

type 's widening_chain =
  | Widening_chain_intro of 's * ('s -> 's widening_chain sumor)

type ('concrete, 'zeroary_ops, 'unary_ops, 'binary_ops) domain = { 
domain_zeroary : ('zeroary_ops -> __);
domain_unary : ('unary_ops -> __ -> __);
domain_binary : ('binary_ops -> __ -> __ -> __);
domain_union : (__ -> __ -> __); domain_le_decide : 
(__ -> __ -> bool); domain_iter_union : (__ -> __ -> __ sig0 sumor);
domain_widening_chain : __ widening_chain }

type ('concrete, 'zeroary_ops, 'unary_ops, 'binary_ops) domain_set = __

val domain_zeroary :
  ('a1, 'a2, 'a3, 'a4) domain -> 'a2 -> ('a1, 'a2, 'a3, 'a4) domain_set

val domain_unary :
  ('a1, 'a2, 'a3, 'a4) domain -> 'a3 -> ('a1, 'a2, 'a3, 'a4) domain_set ->
  ('a1, 'a2, 'a3, 'a4) domain_set

val domain_binary :
  ('a1, 'a2, 'a3, 'a4) domain -> 'a4 -> ('a1, 'a2, 'a3, 'a4) domain_set ->
  ('a1, 'a2, 'a3, 'a4) domain_set -> ('a1, 'a2, 'a3, 'a4) domain_set

val domain_union :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set -> ('a1,
  'a2, 'a3, 'a4) domain_set -> ('a1, 'a2, 'a3, 'a4) domain_set

val domain_le_decide :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set -> ('a1,
  'a2, 'a3, 'a4) domain_set -> bool

val domain_iter_union :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set -> ('a1,
  'a2, 'a3, 'a4) domain_set -> ('a1, 'a2, 'a3, 'a4) domain_set sig0 sumor

val domain_widening_chain :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set
  widening_chain

type ('concrete, 'zeroary_ops, 'unary_ops, 'binary_ops) product_set =
  (('concrete, 'zeroary_ops, 'unary_ops, 'binary_ops) domain_set, ('concrete,
  'zeroary_ops, 'unary_ops, 'binary_ops) domain_set) pair

val product_le_decide :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2,
  'a3, 'a4) product_set -> ('a1, 'a2, 'a3, 'a4) product_set -> bool

val product_zeroary :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> 'a2 -> (('a1,
  'a2, 'a3, 'a4) domain_set, ('a1, 'a2, 'a3, 'a4) domain_set) pair

val product_unary :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> 'a3 -> ('a1,
  'a2, 'a3, 'a4) product_set -> (('a1, 'a2, 'a3, 'a4) domain_set, ('a1, 'a2,
  'a3, 'a4) domain_set) pair

val product_binary :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> 'a4 -> ('a1,
  'a2, 'a3, 'a4) product_set -> ('a1, 'a2, 'a3, 'a4) product_set -> (('a1,
  'a2, 'a3, 'a4) domain_set, ('a1, 'a2, 'a3, 'a4) domain_set) pair

val product_union :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2,
  'a3, 'a4) product_set -> ('a1, 'a2, 'a3, 'a4) product_set -> (('a1, 'a2,
  'a3, 'a4) domain_set, ('a1, 'a2, 'a3, 'a4) domain_set) pair

val product_widening_chain :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2,
  'a3, 'a4) product_set widening_chain

val product_iter_union :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2,
  'a3, 'a4) product_set -> ('a1, 'a2, 'a3, 'a4) product_set -> ('a1, 'a2,
  'a3, 'a4) product_set sig0 sumor

val product_domain :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2,
  'a3, 'a4) domain

val ramp_widening_chain_search :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set -> ('a1,
  'a2, 'a3, 'a4) domain_set list -> ('a1, 'a2, 'a3, 'a4) domain_set list

val ramp_widening_chain :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set list ->
  ('a1, 'a2, 'a3, 'a4) domain_set widening_chain

val add_widening_ramp :
  ('a1, 'a2, 'a3, 'a4) domain -> ('a1, 'a2, 'a3, 'a4) domain_set list ->
  ('a1, 'a2, 'a3, 'a4) domain

val delayed_widening_each_step :
  ('a1, 'a2, 'a3, 'a4) domain -> Int64.t -> ('a1, 'a2, 'a3, 'a4) domain_set
  widening_chain

val delay_widening_each_step :
  ('a1, 'a2, 'a3, 'a4) domain -> Int64.t -> ('a1, 'a2, 'a3, 'a4) domain

val natural_inf_domain_widening_chain : Int64.t widening_chain

val natural_inf_domain_le_decide : Int64.t -> Int64.t -> bool

val natural_inf_domain_iter_union : Int64.t -> Int64.t -> Int64.t sig0 sumor

type natural_inf_domain_zeroary_ops = unit (* empty inductive *)

type natural_inf_domain_unary_ops =
  | Natural_inf_domain_F

type natural_inf_domain_binary_ops = unit (* empty inductive *)

val natural_inf_domain :
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain

val test_domain_ramp1 :
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain

val test_domain_ramp2 :
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain

val test_domain1 :
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain

val test_domain2 :
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain

val test_domain :
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain

val test_f1 :
  Int64.t -> (Int64.t, natural_inf_domain_zeroary_ops,
  natural_inf_domain_unary_ops, natural_inf_domain_binary_ops) domain_set

val test_f2 :
  Int64.t -> (Int64.t, natural_inf_domain_zeroary_ops,
  natural_inf_domain_unary_ops, natural_inf_domain_binary_ops) domain_set

val test_f :
  (Int64.t, Int64.t) pair -> ((Int64.t, natural_inf_domain_zeroary_ops,
  natural_inf_domain_unary_ops, natural_inf_domain_binary_ops) domain_set,
  (Int64.t, natural_inf_domain_zeroary_ops, natural_inf_domain_unary_ops,
  natural_inf_domain_binary_ops) domain_set) pair

val final : (Int64.t, Int64.t) pair

